﻿Imports AD_LDAP.ADHelper

Module Module1

    Const PATH_TO_AD As String = "LDAP://localhost/DC=lynx,DC=local"
    Const SAMPLE_PERSON As String = "LDAP://localhost/CN=Jane Doe,CN=Users,DC=lynx,DC=local"

    Sub Main()

        Dim persons As New List(Of Entity)
        Dim properties As New List(Of String)
        Dim filter As String

        ' this list contains all the properties we want to load from the AD, such as email address, name, home directory, etc.
        properties.Add("samaccountname")
        properties.Add("mail")
        properties.Add("homedirectory")

        ' this is the filter applied to the items returned from the AD. for example, we can select persons only, but also persons from a specific group.
        ' example 1: select persons only
        filter = "(objectCategory=Person)"
        ' example 2: select users who are part of a specific distribution list (a group in AD)
        filter = "(memberOf=CN=DL-All,CN=Users,DC=lynx,DC=local)"

        ' now we collect all the persons from AD that satisfy the filter we just set up. note that only those properties you selected earlier on will be saved!
        persons = GetUsersFromActiveDirectory(PATH_TO_AD, properties, filter)
        ' here we sort the persons in alphabetic order based on a property (in this case: 0 = the user account name)
        SortPersons(properties(0), persons)

        ' now you can do whatever you need to be done with the list of persons
        For Each p As Entity In persons
            Console.WriteLine(p.ToString)
        Next

        Console.ReadKey()

        Console.Clear()
        ' lists all available properties
        Dim props As List(Of String)
        props = GetAllAvailableProperties(SAMPLE_PERSON)

        For Each p As String In props
            Console.WriteLine(p)
        Next

        Console.ReadKey()


    End Sub


End Module
